#line 1 "P:/_Electronique_/_RTC & Timer_/RTC - Horloge Minuterie/RTC8583/RTC Board Examples/16F887/mikroC/ReadWrite time and display it on LCD/RTC_RW.c"
#line 24 "P:/_Electronique_/_RTC & Timer_/RTC - Horloge Minuterie/RTC8583/RTC Board Examples/16F887/mikroC/ReadWrite time and display it on LCD/RTC_RW.c"
struct TTime
{
 char year, month, day, hours, minutes, seconds;
} TimeRW;

char yearmod4, byteRead;

void Display_Time()
{
 char txt[11];

 txt[0] = (TimeRW.day / 10) + 48;
 txt[1] = (TimeRW.day % 10) + 48;
 txt[2] = '/';
 txt[3] = (TimeRW.month / 10) + 48;
 txt[4] = (TimeRW.month % 10) + 48;
 txt[5] = '/';
 txt[6] = '2';
 txt[7] = (TimeRW.year / 100) + 48;
 txt[8] = ((TimeRW.year % 100) / 10) + 48;
 txt[9] = (TimeRW.year % 10) + 48;
 txt[10] = 0;
 Lcd_Out(1,7,txt);

 txt[0] = (TimeRW.hours / 10) + 48;
 txt[1] = (TimeRW.hours % 10) + 48;
 txt[2] = ':';
 txt[3] = (TimeRW.minutes / 10) + 48;
 txt[4] = (TimeRW.minutes % 10) + 48;
 txt[5] = ':';
 txt[6] = (TimeRW.seconds / 10) + 48;
 txt[7] = (TimeRW.seconds % 10) + 48;
 txt[8] = 0;
 Lcd_Out(2,7,txt);
}

void WriteTime()
{
 TimeRW.year = 7;
 TimeRW.month = 12;
 TimeRW.day = 31;
 TimeRW.hours = 23;
 TimeRW.minutes = 59;
 TimeRW.seconds = 40;

 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(0);
 I2C1_Wr(0x80);
 I2C1_Wr(0);
 I2C1_Wr(((TimeRW.seconds/10)<<4) + (TimeRW.seconds%10));
 I2C1_Wr(((TimeRW.minutes/10)<<4) + (TimeRW.minutes%10));
 I2C1_Wr(((TimeRW.hours/10)<<4) + (TimeRW.hours%10));
 I2C1_Wr(((TimeRW.year%4)<<6) + ((TimeRW.day/10)<<4) +(TimeRW.day%10));
 I2C1_Wr(((TimeRW.month/10)<<4) + (TimeRW.month%10));
 I2C1_Stop();

 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(0x10);
 I2C1_Wr(TimeRW.year);
 I2C1_Stop();

 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(0);
 I2C1_Wr(0);
 I2C1_Stop();
}

void ReadTime()
{
 char updateYear;

 updateYear = 0;

 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(2);
 I2C1_Repeated_Start();
 I2C1_Wr(0xA1);

 byteRead = I2C1_Rd(1);
 TimeRW.seconds = (byteRead >> 4)*10 + (byteRead & 0x0F);



 byteRead = I2C1_Rd(1);
 TimeRW.minutes = (byteRead >> 4)*10 + (byteRead & 0x0F);


 byteRead = I2C1_Rd(1);
 TimeRW.hours = (byteRead >> 4)*10 + (byteRead & 0x0F);


 byteRead = I2C1_Rd(1);
 TimeRW.day = ((byteRead & 0b00110000) >> 4)*10 + (byteRead & 0x0F);
 yearmod4 = (byteRead & 0b11000000) >> 6;


 byteRead = I2C1_Rd(0);
 TimeRW.month = ((byteRead & 0b00010000) >> 4)*10 + (byteRead & 0x0F);

 I2C1_Stop();

 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(0x10);
 I2C1_Repeated_Start();
 I2C1_Wr(0xA1);

 byteRead = I2C1_Rd(0);
 if (yearmod4 != byteRead % 4 )
 {
 byteRead++;
 updateYear = 1;
 }
 TimeRW.year = byteRead;


 I2C1_Stop();

 if (updateYear > 0)
 {
 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(0x10);
 I2C1_Wr(TimeRW.year);
 I2C1_Stop();
 }
}


sbit LCD_EN at RB5_bit;
sbit LCD_RS at RB4_bit;

sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_RS_Direction at TRISB4_bit;

sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;





void MainInit()
{
 ANSEL = 0;
 ANSELH = 0;

 Lcd_Init();


 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,"Date:   /  /");
 Lcd_Out(2,1,"Time:   :  :");

 I2C1_Init(10000);

 WriteTime();
}



void main()
{
 MainInit();

 while(1)
 {
 ReadTime();
 Display_Time();
 Delay_ms(1000);
 }
}
